const fs = require('fs')
const clc = require('./clc')
const file = '.256.tmp'
const os = require('os')

const push = function(code, sha256) {
  fs.appendFileSync(file, code + ',' + sha256 + '\n')
}

const generate = function(code, filePath) {
  try {
    const platform = os.platform()
    let r = ''
    switch(platform) {
      case 'win32':
        r = shell.exec(`certutil -hashfile ${filePath} SHA256`)
        push(code, r.split('\n')[1])
        break
      case 'darwin':
        r =shell.exec(`shasum -a 256 ${filePath}`)
        push(code, r.split(' ')[0])
        break
      case 'linux':
        r = shell.exec(`sha256sum ${filePath}`)
        push(code, r.split(' ')[0])
        break
      default:
        break
    }
  } catch(e) {
    console.error(e)
    clc.red('failed to compute sha256')
  }
}

const create = function() {
  fs.writeFileSync(file, '')
}

const close = function() {
  if (fs.existsSync(file)) fs.unlinkSync(file)
}

const show = function() {
  const content = fs.readFileSync(file, { encoding: 'utf8' })
  const lines = content.split('\n')
  lines.forEach((line) => {
    if (line) {
      const [code, sha256] = line.split(',')
      clc.green(`Sha256 sum of package ${code} is ${sha256}`)
    }
  })
}

module.exports.generate = generate
module.exports.create = create
module.exports.close = close
module.exports.push = push
module.exports.show = show
