import WechatConfigCard from './custom-component/wechat-config-card/wechat-config-card.vue'
import WecomConfigDrawer from './custom-component/we-com/config-drawer.vue'
import queryCorpId from './tools/query-wecom-config-by-id'
import store from './store/store'
import registerI18n from '../common/register-i18n'
import locale from './locale'
const install = function (context, hookManager, definition) {
  const i18n = registerI18n(context, locale, definition)
  if (context.$store) {
    context.$store.$registerModule('customPluginWecom', store)
  }
  hookManager.onHook('openConfigDrawer', () => {
    return 'WecomConfigDrawer'
  })
  hookManager.onHook('getRemindWayList', () => {
    return {
      code: 'WORK_WECHAT',
      name: (i18n && i18n.t('messageRemindModal.remindWay.wecomLabel')) || '企微',
      description: (i18n && i18n.t('messageRemindModal.remindWay.wecomTitle')) || '需在插件管理中完成企业微信集成配置',
      priority: 3
    }
  })
  hookManager.onHook('getAppConfigCard', (vmParams, vm) => {
    return 'WechatConfigCard'
  })
  hookManager.onHook('queryAppAdvancedConfig', (vmParams, vm) => {
    return queryCorpId(vmParams, vm)
  })
}

const staticComponents = [WechatConfigCard, WecomConfigDrawer]

export default { install, staticComponents }
