import apis from '../api'
import generateWecomUrl from './generate-wecom-url'
const queryCorpId = function ({ appInfo, tenantId }, vm) {
  const request = { ...apis.GET_WECOM_CORP_ID }
  vm.$store.commit('customPluginWecom/modifyCorpId', '')
  vm.$request(request)
    .then(
      (resp) => {
        if (resp.code === 'ok') {
          vm.$store.commit('customPluginWecom/modifyCorpId', resp.data.corpId)
          return queryWeChatConfig({ appInfo, tenantId, corpId: resp.data.corpId }, vm)
        } else {
          return Promise.reject(new Error(''))
        }
      }
    )
}

const queryWeChatConfig = function ({ appInfo, tenantId, corpId }, vm) {
  const request = {
    ...apis.QUERY_WECHAT_CONFIG,
    params: {
      appId: appInfo.id,
      tenantId: tenantId
    }
  }
  return vm.$request(request)
    .then(
      (resp) => {
        if (resp.code === 'ok') {
          if (resp.data.length > 0) {
            vm.$store.commit('customPluginWecom/modifyWecomConfigByApp', {
              ...resp.data[0],
              ...generateWecomUrl(resp.data[0], corpId, vm),
              appName: appInfo.appName
            })
          } else {
            vm.$store.commit('customPluginWecom/modifyWecomConfigByApp', {})
          }
        } else {
          return Promise.reject(new Error(''))
        }
      }
    )
}

export default queryCorpId
