import { isString, isFunction } from '../utils/type'
import { RequiredValidator } from '../validator/index'

export default {
  methods: {
    /**
     * 生成统一的验证器
     *
     * @param {string or validaor} type 生成字符串 和 验证器
     * @param {any} message
     * @param {string} [trigger=['blur', 'change']]
     * @param {string} [isI18n='true']
     * @returns
     */
    _validate(type, message, trigger = ['blur', 'change'], isI18n = 'true') {
      // 生成验证器
      const validator = {
        trigger: trigger
      }
      if (isString(type)) {
        validator.type = type
        if (type === 'required') {
          validator.validator = RequiredValidator(isI18n ? this.$t(message) : message)
        }
        validator.message = isI18n ? this.$t(message) : message
      } else if (isFunction(type)) {
        validator.validator = type
      }

      return validator
    }
  }
}
