import { isString } from '../utils/type'

/**
 * 正则表达式校验
 * @param {*} regex 正则或正则字符串
 * @param {*} errorMsg 错误提示
 */
const RegexValidator = (regex, errorMsg) => {
  let reg
  if (isString(regex)) {
    reg = new RegExp(regex)
  } else {
    reg = regex
  }
  return (rule, value, callback) => {
    if (!reg.test(value)) {
      callback(new Error(errorMsg))
    } else {
      callback()
    }
  }
}

export default RegexValidator
